#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2thirtythree4search.py">
#<abstract4xi abstract = "shoots to direction thirtythree"/>
#<refer4xi reference = "analyse2photo4search.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2thirtythree4search']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 


#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI   
try:    
    from dummyprocess4xi import DummyProcess4Xi
except:
    print("*** gun2thirtythree4search: *** error: from dummyprocess4xi import DummyProcess4Xi ***")
    
try:    
    from process4xi import Process4Xi
except:
    print("*** gun2thirtythree4search: *** error: from process4xi import Process4Xi ***")    
     
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global base2build4thirtythree

global count2ack4thirtythree
global count2nack4thirtythree
global count2found4thirtythree
global count2short4thirtythree

global current2series4thirtythree
global candidate2series4thirtythree

global fileobject4thirtythree  

global keys2profile4thirtythree
global key2profile4thirtythree

global left2find4thirtythree

global maxsize2ack4thirtythree    
global maxsize2file4thirtythree 
global max2short4thirtythree
global meansize2ack4thirtythree
global minsize2ack4thirtythree

global thirtythree2analyse4search

global profile2fetch4thirtythree

global right2find4thirtythree

global sumsize2ack4thirtythree    

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
base2build4thirtythree = VersionKB4Xi['base2shoot4thirtythree']             # base internet address, None=local url

count2ack4thirtythree   = 0
count2nack4thirtythree  = 0
count2found4thirtythree = 0
count2short4thirtythree = 0

left2find4thirtythree = '('

max2short4thirtythree = VersionKB4Xi['max2short4thirtythree']
maxsize2file4thirtythree = VersionKB4Xi['maxsize2file4thirtythree']
maxsize2ack4thirtythree  = 0
meansize2ack4thirtythree = 0
minsize2ack4thirtythree  = 0

current2series4thirtythree = "current2series4thirtythree5dummy"
candidate2series4thirtythree  = "candidate2series4thirtythree5dummy"


thirtythree2analyse4search  = VersionKB4Xi['thirtythree2analyse4search']

profile2fetch4thirtythree = {}
profile2fetch4thirtythree [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch4thirtythree [2] = '.jpg'
keys2profile4thirtythree = profile2fetch4thirtythree.keys()

right2find4thirtythree = ')'

sumsize2ack4thirtythree  = 0

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4thirtythree" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4thirtythree(target2explore4thirtythree):
    global count2ack4thirtythree
    global count2nack4thirtythree
    global count2found4thirtythree
    global count2short4thirtythree
    
    global fileobject4thirtythree 
       
    global keys2profile4thirtythree
    global key2profile4thirtythree
    
    global left2find4thirtythree

    global max2short4thirtythree    
    global maxsize2file4thirtythree     
    global maxsize2ack4thirtythree    
    global meansize2ack4thirtythree
    global minsize2ack4thirtythree
  
    global candidate2series4thirtythree
    global current2series4thirtythree
    
    
    global profile2fetch4thirtythree                         # extension for files
    
    global right2find4thirtythree
    
    global sumsize2ack4thirtythree    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    count2found4thirtythree = count2found4thirtythree + 1
    ack2debug4thirtythree = False                            # <-- True
 
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4thirtythree)
    
    ack2profile = False
    for key2profile4thirtythree in keys2profile4thirtythree:
        if name2target[1] == profile2fetch4thirtythree[key2profile4thirtythree]:                                                             
            ack2profile = True
    
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF SHOOT2THIRTYTHREE4SEARCH - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4thirtythree
        if ack2debug4thirtythree is True:
            print("(STEP 0A/33) OF SHOOT2THIRTYTHREE4SEARCH - PATH2INPUT: ", path2input) 
            #  
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF SHOOT2THIRTYTHREE4SEARCH - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        size2file = status2file.st_size
        if size2file > maxsize2file4thirtythree:
            count2nack4thirtythree = count2nack4thirtythree + 1
        else:
            count2ack4thirtythree = count2ack4thirtythree + 1
            sumsize2ack4thirtythree = sumsize2ack4thirtythree + size2file
            if size2file > maxsize2ack4thirtythree:
                maxsize2ack4thirtythree = size2file
            if ((size2file < minsize2ack4thirtythree) or (minsize2ack4thirtythree == 0)):
                print("(STEP 0B/33) OF SHOOT2THIRTYTHREE4SEARCH - USING MINSIZE2ACK4THIRTYTHREE: ", minsize2ack4thirtythree, " SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # USING MINSIZE2ACK4THIRTYTHREE:  0  SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2thirtythree//d\thirtythreefly29july2012\thirtythreefly29july2012 (1).JPG 
                # USING MINSIZE2ACK4THIRTYTHREE:  3866624  SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2thirtythree//d\thirtythreefly29july2012\thirtythreefly29july2012 (2).JPG
                minsize2ack4thirtythree = size2file
                print("(STEP 0C/33) OF SHOOT2THIRTYTHREE4SEARCH - SET MINSIZE2ACK4THIRTYTHREE TO: ", minsize2ack4thirtythree, " = SIZE2FILE: ", size2file ," PATH2INPUT: ", path2input) 
                # SET MINSIZE2ACK4THIRTYTHREE TO:  3866624  = SIZE2FILE:  3866624  PATH2INPUT:  F://temp//yophotos//test2thirtythree//d\thirtythreefly29july2012\thirtythreefly29july2012 (1).JPG
                # SET MINSIZE2ACK4THIRTYTHREE TO:  3538944  = SIZE2FILE:  3538944  PATH2INPUT:  F://temp//yophotos//test2thirtythree//d\thirtythreefly29july2012\thirtythreefly29july2012 (2).JPG
                            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        try:
            url2web4thirtythree = target2explore4thirtythree
            if ack2debug4thirtythree is True:print("(STEP 1A/33) OF SHOOT2THIRTYTHREE4SEARCH - URL2WEB4THIRTYTHREE: ", url2web4thirtythree) 
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4thirtythree,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4thirtythree = url2web4thirtythree[0:index2edit] + string2use + url2web4thirtythree[index2edit+1:]
                        
            name2web=os.path.splitext(url2web4thirtythree)
            shortname2web4thirtythree = name2web[0]
            if ack2debug4thirtythree is True:
                print("(STEP 1B/33) OF SHOOT2THIRTYTHREE4SEARCH - SHORTNAME2WEB4THIRTYTHREE: ", shortname2web4thirtythree)
                # 
            
            string2find4thirtythree = '/'
            ackall2found4thirtythree = False           
            while 1:
                if ackall2found4thirtythree is True:
                    break
                else:
                    index2find4thirtythree=str.find(shortname2web4thirtythree,string2find4thirtythree)   
                    if index2find4thirtythree == -1:
                        ackall2found4thirtythree = True
                    else:
                        shortname2web4thirtythree = shortname2web4thirtythree[index2find4thirtythree+1:]
                        
            if ack2debug4thirtythree is True:            
                print("(STEP 1C/33) OF SHOOT2THIRTYTHREE4SEARCH - SHORTNAME2WEB4THIRTYTHREE: ", shortname2web4thirtythree)
                # 
                
            ackall2found4thirtythree = False 
            while 1:
                if ackall2found4thirtythree is True:
                    break
                else:
                    index2left4thirtythree=str.find(shortname2web4thirtythree,left2find4thirtythree)
                    if index2left4thirtythree == -1:
                        current2series4thirtythree = shortname2web4thirtythree
                        if ack2debug4thirtythree is True:
                            print("(STEP 2A/33) OF SHOOT2THIRTYTHREE4SEARCH - CURRENT2SERIES4THIRTYTHREE: ", current2series4thirtythree) 
                            # 
                        ackall2found4thirtythree = True
                         
                    else:
                        index2right4thirtythree=str.find(shortname2web4thirtythree,right2find4thirtythree)
                        if index2right4thirtythree == -1:
                            ackall2found4thirtythree = True 
                        else:
                            candidate2series4thirtythree = shortname2web4thirtythree[0:index2left4thirtythree]
                            
                            index3find4thirtythree=str.find(shortname2web4thirtythree,current2series4thirtythree)
                            if index3find4thirtythree == -1:
                                
                                current2series4thirtythree = candidate2series4thirtythree
                                if ack2debug4thirtythree is True:
                                    print("(STEP 2B/33) OF SHOOT2THIRTYTHREE4SEARCH - CURRENT2SERIES4THIRTYTHREE: ", current2series4thirtythree) 
                                    # 
                                
                                count2short4thirtythree = 0
                                fileobject4thirtythree.write('<br />' + '\n')
                            else:
                                shortname2web4thirtythree = shortname2web4thirtythree[index2left4thirtythree:index2right4thirtythree+1]
                                if ack2debug4thirtythree is True:
                                    print("(STEP 2C/33) OF SHOOT2THIRTYTHREE4SEARCH - SHORTNAME2WEB4THIRTYTHREE: ", shortname2web4thirtythree)
                                    # 
                                
                                count2short4thirtythree = count2short4thirtythree + 1
                                if count2short4thirtythree >= max2short4thirtythree:
                                    count2short4thirtythree = 0
                                else:
                                    pass       
                            ackall2found4thirtythree = True
   
                                  
            # =======================================================================================================================
            # 
            # =======================================================================================================================                    
            if base2build4thirtythree is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject4thirtythree.write('<br /><b>&raquo;</b><a href="' + url2web4thirtythree + '" target="_blank">' + shortname2web4thirtythree + '</a>\n')                       
                
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2local4thirtythree = thirtythree2analyse4search
                if ack2debug4thirtythree is True:
                    print("(STEP 3A/33) OF SHOOT2THIRTYTHREE4SEARCH - BASE2LOCAL4THIRTYTHREE: ", base2local4thirtythree)
                    #              
                ack2localtries4thirtythree = False                   
                while 1:
                    if ack2localtries4thirtythree is True:
                        break
                    else:
                        index2find4thirtythree=str.find(url2web4thirtythree,base2local4thirtythree)            
                        # 
                        #  
                        if index2find4thirtythree == -1:
                            ack2localtries4thirtythree = True
                        else:
                            if ack2debug4thirtythree is True:
                                print("(STEP 3B/33) OF SHOOT2THIRTYTHREE4SEARCH - BASE2BUILD4THIRTYTHREE: ", base2build4thirtythree)
                                # 
                            url2web4thirtythree = base2build4thirtythree + url2web4thirtythree[len(base2local4thirtythree):]
                            if ack2debug4thirtythree is True:
                                print("(STEP 3C/33) OF SHOOT2THIRTYTHREE4SEARCH - URL2WEB4THIRTYTHREE: ", url2web4thirtythree)
                                # 
                            
                            if count2short4thirtythree < 1: 
                                fileobject4thirtythree.write('<br /><b>&raquo;</b><a href="' + url2web4thirtythree + '" target="_blank">' + shortname2web4thirtythree + '</a>' + '\n')
                            else:
                                fileobject4thirtythree.write('<b>&raquo;</b><a href="' + url2web4thirtythree + '" target="_blank">' + shortname2web4thirtythree + '</a>\n')                            
                            ack2localtries4thirtythree = True 
                        
        except:
            print("(Step 4Z1/33 OF SHOOT2THIRTYTHREE4SEARCH FAILED, FILEOBJECT4THIRTYTHREE-WRITE-FAILED: ", str(fileobject4thirtythree), time4xi())
      
    else:
        
        count2nack4thirtythree = count2nack4thirtythree + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2thirtythree4search" usage = "analysing content">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2thirtythree4search(queue2thirtythree = None, consumer_channel2thirtythree = None, publisher_channel2thirtythree = None, path2thirtythree = None):
    '''
    communicates via the given queue and named pipe channels if multiprocessing4xi is being used 
    '''
    global count2ack4thirtythree
    global count2nack4thirtythree
    global count2found4thirtythree
    
    global fileobject4thirtythree    
    
    global maxsize2ack4thirtythree    
    global meansize2ack4thirtythree
    global minsize2ack4thirtythree
    global sumsize2ack4thirtythree    
    
    global maxsize2file4thirtythree 
    
    global profile2fetch4thirtythree                         # extension for files
    global keys2profile4thirtythree
    global key2profile4thirtythree

        
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("(STEP 0A/33) OF SHOOT2THIRTYTHREE4SEARCH - STARTED TIME: ", time2start)   
    # 
    print("(STEP 0B/33) OF SHOOT2THIRTYTHREE4SEARCH -  QUEUE2THIRTYTHREE: ", queue2thirtythree)      
    # QUEUE2THIRTYTHREE:  <queue4xi.Queue4Xi object at 0x02A5D930>
    
    print("(STEP 0C/33) OF SHOOT2THIRTYTHREE4SEARCH -  CONSUMER_CHANNEL2THIRTYTHREE: ", consumer_channel2thirtythree)
    # CONSUMER_CHANNEL2THIRTYTHREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
          
    print("(STEP 0D/33) OF SHOOT2THIRTYTHREE4SEARCH -  PUBLISHER_CHANNEL2THIRTYTHREE: ", publisher_channel2thirtythree)          
    # PUBLISHER_CHANNEL2THIRTYTHREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>

    if ((queue2thirtythree is None) or (consumer_channel2thirtythree is None) or (publisher_channel2thirtythree is None)):
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED
        # -----------------------------------------------------------------------------------------
        print("(STEP 1A/33) OF SHOOT2THIRTYTHREE4SEARCH - COMMAND AND CONTROL MECHANISM NOT GIVEN - MULTIPROCESSING NOT USED")
        print("(STEP 1B/33) OF SHOOT2THIRTYTHREE4SEARCH - QUEUE2THIRTYTHREE: ", queue2thirtythree)
        print("(STEP 1C/33) OF SHOOT2THIRTYTHREE4SEARCH - CONSUMER_CHANNEL2THIRTYTHREE: ", consumer_channel2thirtythree) 
        print("(STEP 1D/33) OF SHOOT2THIRTYTHREE4SEARCH - PUBLISHER_CHANNEL2THIRTYTHREE: ", publisher_channel2thirtythree)
        print("(STEP 1E/33) OF SHOOT2THIRTYTHREE4SEARCH - PATH2THIRTYTHREE: ", path2thirtythree)     
        
        return
 
    if (not (queue2thirtythree is None) and not(consumer_channel2thirtythree is None) and not(publisher_channel2thirtythree is None) and (path2thirtythree is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL (CC) MECHANISM OK, BUT PATH MISSING - CAN BE USED FOR TESTING CC 
        # -----------------------------------------------------------------------------------------
        print("(STEP 2A/33) OF SHOOT2THIRTYTHREE4SEARCH - COMMAND AND CONTROL MECHANISM OK, BUT PATH MISSING")                       
        print("(STEP 2B/33) OF SHOOT2THIRTYTHREE4SEARCH - QUEUE2THIRTYTHREE: ", queue2thirtythree)
        print("(STEP 2C/33) OF SHOOT2THIRTYTHREE4SEARCH - CONSUMER_CHANNEL2THIRTYTHREE: ", consumer_channel2thirtythree) 
        print("(STEP 2D/33) OF SHOOT2THIRTYTHREE4SEARCH - PUBLISHER_CHANNEL2THIRTYTHREE: ", publisher_channel2thirtythree)
        print("(STEP 2E/33) OF SHOOT2THIRTYTHREE4SEARCH - PATH2THIRTYTHREE: ", path2thirtythree)     
        return           

    if (not (queue2thirtythree is None) and not(consumer_channel2thirtythree is None) and not(publisher_channel2thirtythree is None) and not(path2thirtythree is None)): 
        # -----------------------------------------------------------------------------------------
        # COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN - PRODUCTION VERSION
        # -----------------------------------------------------------------------------------------
        print("(STEP 3A/33) OF SHOOT2THIRTYTHREE4SEARCH - COMMAND AND CONTROL MECHANISM OK AND PATH ALSO GIVEN")                       
        
        print("(STEP 3B/33) OF SHOOT2THIRTYTHREE4SEARCH - QUEUE2THIRTYTHREE: ", queue2thirtythree)
        # QUEUE2THIRTYTHREE:  <queue4xi.Queue4Xi object at 0x02A5D930>
         
        print("(STEP 3C/33) OF SHOOT2THIRTYTHREE4SEARCH - CONSUMER_CHANNEL2THIRTYTHREE: ", consumer_channel2thirtythree)
        # CONSUMER_CHANNEL2THIRTYTHREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5DB10>
        print("(STEP 3D/33) OF SHOOT2THIRTYTHREE4SEARCH - PUBLISHER_CHANNEL2THIRTYTHREE: ", publisher_channel2thirtythree)
        # PUBLISHER_CHANNEL2THIRTYTHREE:  <pipeconnection4xi.PipeConnection4Xi object at 0x02A5D4F0>
        print("(STEP 3E/33) OF SHOOT2THIRTYTHREE4SEARCH - PATH2THIRTYTHREE: ", path2thirtythree)
        # PATH2THIRTYTHREE:  F://temp//yophotos//test2thirtythree//
       
        print("(STEP 4A/33) OF SHOOT2THIRTYTHREE4SEARCH - STARTING TO WALK PATH2THIRTYTHREE: ", path2thirtythree)   
        # STARTING TO WALK PATH2THIRTYTHREE:  F://temp//yophotos//test2thirtythree//
        
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4thirtythree = None
        try:
            name2index4thirtythree = "index2xxxxxxxx4yo.html"
            path2index4thirtythree = path2thirtythree + name2index4thirtythree
            print("(Step 4B/33) OF SHOOT2THIRTYTHREE4SEARCH - SET PATH2INDEX4THIRTYTHREE TO: ", path2index4thirtythree)
            # R://temp//yophotos//test//index2xxxxxxxx4yo.html
        except:
            print("(Step 4Z1/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO INITIALIZE PATH2INDEX4THIRTYTHREE: ", path2index4thirtythree)          
            #                    
        fileobject4thirtythree = None
        try:
            fileobject4thirtythree = open(path2index4thirtythree,'w')
            print("(Step 4C/33) OF SHOOT2THIRTYTHREE4SEARCH - OPENED OUTPUT: ", fileobject4thirtythree)
            # SHOOT2THIRTYTHREE4SEARCH - OPENED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2thirtythree//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 4Z2/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO OPEN OUTPUT: ", fileobject4thirtythree)         
            # 
        try:                
            fileobject4thirtythree.write('<html>\n')
            
            fileobject4thirtythree.write('<style type="text/css" media="all">\n')
            fileobject4thirtythree.write(' @import "http://www.yourthirtythreexi.org/css/halongbay.css";\n')
            fileobject4thirtythree.write('</style> \n')
            fileobject4thirtythree.write('<p>\n')
            fileobject4thirtythree.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4thirtythree.write('<br /><a id="000">yourthirtythree<b>&Xi;</b> @Content</a>\n')
            fileobject4thirtythree.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4thirtythree.write('<br /> \n')

        except:
            print("(Step 4Z3/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4thirtythree)         
            #      
        
        
        KB2name4thirtythree = {}
        key2name4thirtythree = 0
                 
        for file2walk in DirectoryWalker(path2thirtythree):
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                try:    
                    KB2name4thirtythree [key2name4thirtythree] = file2walk
                    print ("KB2NAME4THIRTYTHREE[", key2name4thirtythree, "]: ", KB2name4thirtythree [key2name4thirtythree])
                    # 
                    
                    key2name4thirtythree = key2name4thirtythree + 1

                except:
                    print ("(Step 4Z1/33) OF SHOOT2THIRTYTHREE4SEARCH - FAILED UPDATING KB2NAME4THIRTYTHREE WITH FILE2WALK: " + file2walk + '\n')     
            else:
                build2hyperlink4thirtythree(file2walk)
        
        # --------------------------------------------------------------------------------------------- 
        # END
        # --------------------------------------------------------------------------------------------- 
        try:
            fileobject4thirtythree.write('<br /> \n')
            fileobject4thirtythree.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4thirtythree.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4thirtythree.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4thirtythree.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4thirtythree.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4thirtythree.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4thirtythree.write('</p>\n')
            # 
            fileobject4thirtythree.write('</html>\n')
        except:
            print("(Step 4Z4/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO WRITE TO OUTPUT: ", fileobject4thirtythree)         
            #            
        try:    
            fileobject4thirtythree.close()
            print("(Step 4C/33) OF SHOOT2THIRTYTHREE4SEARCH - CLOSED OUTPUT: ", fileobject4thirtythree)         
            # SHOOT2THIRTYTHREE4SEARCH - CLOSED OUTPUT:  <_io.TextIOWrapper name='F://temp//yophotos//test2thirtythree//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>   
        except:
            print("(Step 4Z5/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO CLOSE OUTPUT: ", fileobject4thirtythree)         
            #                  
                
                
        print("(STEP 5A/33) OF SHOOT2THIRTYTHREE4SEARCH - STARTING TO ANALYSE KB2NAME4THIRTYTHREE: ", time4xi())
        # STARTING TO ANALYSE KB2NAME4THIRTYTHREE:  11:44:16 01/20/15 FLE Standard Time
        
        AlphaKB4thirtythree  = {}
        AlphaKB4thirtythree['a'] = {}
        AlphaKB4thirtythree['b'] = {}
        AlphaKB4thirtythree['c'] = {}
        AlphaKB4thirtythree['d'] = {}
        AlphaKB4thirtythree['e'] = {}
        AlphaKB4thirtythree['f'] = {}
        AlphaKB4thirtythree['g'] = {}
        AlphaKB4thirtythree['h'] = {}
        AlphaKB4thirtythree['i'] = {}
        AlphaKB4thirtythree['j'] = {}
        AlphaKB4thirtythree['k'] = {}
        AlphaKB4thirtythree['l'] = {}
        AlphaKB4thirtythree['m'] = {}
        AlphaKB4thirtythree['n'] = {}
        AlphaKB4thirtythree['o'] = {}
        AlphaKB4thirtythree['p'] = {}
        AlphaKB4thirtythree['q'] = {}
        AlphaKB4thirtythree['r'] = {}
        AlphaKB4thirtythree['s'] = {}
        AlphaKB4thirtythree['t'] = {}
        AlphaKB4thirtythree['u'] = {}
        AlphaKB4thirtythree['v'] = {}
        AlphaKB4thirtythree['w'] = {}
        AlphaKB4thirtythree['x'] = {}
        AlphaKB4thirtythree['y'] = {}
        AlphaKB4thirtythree['z'] = {} 
        keys2AlphaKB4thirtythree = AlphaKB4thirtythree.keys()
        key2AlphaKB4thirtythree  = 0
        
        
        # LEVELS FOR PATH
        KB2level1 = {}
        KB2level2 = {}
        KB2level3 = {}
        KB2level4 = {}
        KB2level5 = {}
        KB2level6 = {}
        KB2level7 = {}
        KB2level8 = {}
        
        key2level1 = 0
        key2level2 = 0
        key2level3 = 0
        key2level4 = 0
        key2level5 = 0
        key2level6 = 0
        key2level7 = 0
        key2level8 = 0
        
        len2cut4thirtythree = len(path2thirtythree)
        # 
        
        keys2name4thirtythree = KB2name4thirtythree.keys()
                
        for key2name4thirtythree in sorted(keys2name4thirtythree):
            # 
            name2optimize4thirtythree = KB2name4thirtythree[key2name4thirtythree]
            # 
            shortcut2level4thirtythree = name2optimize4thirtythree[len2cut4thirtythree:]
            # 
            len2shortcut4thirtythree = len(shortcut2level4thirtythree)
            if len2shortcut4thirtythree == 1:
                try:
                    # LEVEL THIRTYTHREE CONSISTS OF ALPHABETIC FOLDERS A ... Z
                    if shortcut2level4thirtythree in keys2AlphaKB4thirtythree:
                        KB2level1[key2level1] = shortcut2level4thirtythree
                        # 
                        key2level1 = key2level1 + 1
                    else:
                        print ("(Step 5Z1/33) OF SHOOT2THIRTYTHREE4SEARCH ** WARNING - SHORTCUT2LEVEL4THIRTYTHREE: ", shortcut2level4thirtythree, " NOT IN KEYS2ALPHAKB4THIRTYTHREE: ", keys2AlphaKB4thirtythree)
                except:
                        print ("(Step 5Z2/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED - SHORTCUT2LEVEL4THIRTYTHREE: ", shortcut2level4thirtythree)      
            else:
                try:
                    
                    string2search4thirtythree = '\\'
                    shortcut2level4thirtythree = shortcut2level4thirtythree[2:]
                    
                    index2level4thirtythree=str.find(shortcut2level4thirtythree,string2search4thirtythree)
                    if index2level4thirtythree == -1:
                         
                        KB2level2[key2level2] = shortcut2level4thirtythree
                        key2level2 = key2level2 + 1
                    else:    
                        shortcut2level4thirtythree = shortcut2level4thirtythree[index2level4thirtythree+1:]
                        index2level4thirtythree=str.find(shortcut2level4thirtythree,string2search4thirtythree)
                        if index2level4thirtythree == -1:
                            KB2level3[key2level3] = shortcut2level4thirtythree
                            key2level3 = key2level3 + 1
                        else:
                            shortcut2level4thirtythree = shortcut2level4thirtythree[index2level4thirtythree+1:]
                            index2level4thirtythree=str.find(shortcut2level4thirtythree,string2search4thirtythree)
                            if index2level4thirtythree == -1:
                                KB2level4[key2level4] = shortcut2level4thirtythree
                                key2level4 = key2level4 + 1
                            else:
                                shortcut2level4thirtythree = shortcut2level4thirtythree[index2level4thirtythree+1:]
                                index2level4thirtythree=str.find(shortcut2level4thirtythree,string2search4thirtythree)
                                if index2level4thirtythree == -1:
                                    KB2level5[key2level5] = shortcut2level4thirtythree
                                    key2level5 = key2level5 + 1
                                else: 
                                    shortcut2level4thirtythree = shortcut2level4thirtythree[index2level4thirtythree+1:]
                                    index2level4thirtythree=str.find(shortcut2level4thirtythree,string2search4thirtythree)
                                    if index2level4thirtythree == -1:
                                        KB2level6[key2level6] = shortcut2level4thirtythree
                                        key2level6 = key2level6 + 1
                                    else:
                                        shortcut2level4thirtythree = shortcut2level4thirtythree[index2level4thirtythree+1:]
                                        index2level4thirtythree=str.find(shortcut2level4thirtythree,string2search4thirtythree)
                                        if index2level4thirtythree == -1:
                                            KB2level7[key2level7] = shortcut2level4thirtythree
                                            key2level7 = key2level7 + 1
                                        else:
                                            shortcut2level4thirtythree = shortcut2level4thirtythree[index2level4thirtythree+1:]
                                            index2level4thirtythree=str.find(shortcut2level4thirtythree,string2search4thirtythree)
                                            if index2level4thirtythree == -1:
                                                KB2level8[key2level8] = shortcut2level4thirtythree
                                                key2level8 = key2level8 + 1                
                                            else:
                                                print ("(Step 5Z2/33) OF SHOOT2THIRTYTHREE4SEARCH ** WARNING: MOTE THAN 8 LEVELS, SHORTCUT2LEVEL4THIRTYTHREE: ", shortcut2level4thirtythree)
                except:
                    print ("(Step 5Z3/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED - SHORTCUT2LEVEL4THIRTYTHREE: ", shortcut2level4thirtythree)   
        
        print ("(Step 6A/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level1 ", time4xi())       
        # SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level1  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level1 = KB2level1.keys()
            for key2Level1 in sorted(keys2Level1):
                print (KB2level1[key2Level1])      
                # a ... z          
        except:
            print ("(Step 6Z1/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level1 ", time4xi())    

        print ("(Step 6B/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level2 ", time4xi())        
        # SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level2  11:44:16 01/20/15 FLE Standard Time
        try:
            keys2Level2 = KB2level2.keys()
            for key2Level2 in sorted(keys2Level2):
                print (KB2level2[key2Level2])      
                # thirtythreefly29july2012    
        except:
            print ("(Step 6Z2/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level2 ", time4xi()) 
            
        print ("(Step 6C/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level3 ", time4xi())       
        try:
            keys2Level3 = KB2level3.keys()
            for key2Level3 in sorted(keys2Level3):
                print (KB2level3[key2Level3])      
                # 
        except:
            print ("(Step 6Z3/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level3 ", time4xi())             
        
        print ("(Step 6D/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level4 ", time4xi())       
        # 
        try:
            keys2Level4 = KB2level4.keys()
            for key2Level4 in sorted(keys2Level4):
                print (KB2level4[key2Level4])      
                #            
        except:
            print ("(Step 6Z4/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level4 ", time4xi())                                         
        
        print ("(Step 6E/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level5 ", time4xi())       
        # 
        try:
            keys2Level5 = KB2level5.keys()
            for key2Level5 in sorted(keys2Level5):
                print (KB2level5[key2Level5])      
                #              
        except:
            print ("(Step 6Z5/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level5 ", time4xi())             
        
        print ("(Step 6F/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level6 ", time4xi())       
        # 
        try:
            keys2Level6 = KB2level6.keys()
            for key2Level6 in sorted(keys2Level6):
                print (KB2level6[key2Level6])      
                #              
        except:
            print ("(Step 6Z6/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level6 ", time4xi())             
    
        print ("(Step 6G/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level7 ", time4xi())       
        # 
        try:
            keys2Level7 = KB2level7.keys()
            for key2Level7 in sorted(keys2Level7):
                print (KB2level7[key2Level7])      
                #              
        except:
            print ("(Step 6Z7/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level7 ", time4xi()) 
            
        print ("(Step 6H/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT KB2level8 ", time4xi())       
        # 
        try:
            keys2Level8 = KB2level8.keys()
            for key2Level8 in sorted(keys2Level8):
                print (KB2level8[key2Level8])      
                #              
        except:
            print ("(Step 6Z8/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT KB2level8 ", time4xi())         
        
        print ("(Step 7A/33) OF SHOOT2THIRTYTHREE4SEARCH - TRYING TO PRINT STATISTICS ", time4xi())   
        #     
        try:    
            print ("(Step 7B/33) OF SHOOT2THIRTYTHREE4SEARCH - COUNT2ACK4THIRTYTHREE; ", count2ack4thirtythree)
            # COUNT2ACK4THIRTYTHREE;  3 <-- *.jpg
            print ("(Step 7C/33) OF SHOOT2THIRTYTHREE4SEARCH - COUNT2NACK4THIRTYTHREE; ", count2nack4thirtythree)
            # COUNT2NACK4THIRTYTHREE;  2 <-- index.html
            print ("(Step 7D/33) OF SHOOT2THIRTYTHREE4SEARCH - COUNT2FOUND4THIRTYTHREE: ", count2found4thirtythree)
            # COUNT2FOUND4THIRTYTHREE:  5 <-- all files
        except:
             print ("(Step 7Z1/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:  
            print ("(Step 7E/33) OF SHOOT2THIRTYTHREE4SEARCH - FOUND MAX SIZE: ", maxsize2ack4thirtythree)
            #  3866624
            print ("(Step 7F/33) OF SHOOT2THIRTYTHREE4SEARCH - ALLOWED MAX SIZE: ", maxsize2file4thirtythree)
            # 33000000
        except:
             print ("(Step 7Z2/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
        
        try:         
            if count2found4thirtythree == 0:
                meansize2ack4thirtythree = 0
                print ("(Step 7G1/33) OF SHOOT2THIRTYTHREE4SEARCH - MEAN SIZE SET: ", meansize2ack4thirtythree)
                #  
            else:       
                meansize2ack4thirtythree = int(sumsize2ack4thirtythree / count2ack4thirtythree)
                print ("(Step 7G2/33) OF SHOOT2THIRTYTHREE4SEARCH - MEAN SIZE CALCULATED: ", meansize2ack4thirtythree, ", WHERE SUMSIZE2ACK4THIRTYTHREE: ", sumsize2ack4thirtythree, " COUNT2ACK4THIRTYTHREE: ", count2ack4thirtythree)
                # MEAN SIZE CALCULATED:  3648170 , WHERE SUMSIZE2ACK4THIRTYTHREE:  10944512  COUNT2ACK4THIRTYTHREE:  3 
        except:
             print ("(Step 7Z3/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO CALCULATE STATISTICS ", time4xi())
        
        try:                 
            if minsize2ack4thirtythree < maxsize2file4thirtythree:
                print ("(Step 7H/33) OF SHOOT2THIRTYTHREE4SEARCH - MIN SIZE MET: ", minsize2ack4thirtythree)
                # 3538944
            else:
                print ("(Step 7I/33) OF SHOOT2THIRTYTHREE4SEARCH ** MIN DEFINED: ", minsize2ack4thirtythree, " EQUALS TO MAXSIZE2FILE4THIRTYTHREE: ", maxsize2file4thirtythree)        
        except:
             print ("(Step 7Z4/33) OF SHOOT2THIRTYTHREE4SEARCH *** FAILED TO PRINT STATISTICS ", time4xi())
             
                         
        print("(STEP 4Y/33) OF SHOOT2THIRTYTHREE4SEARCH - RETURNING: ", time4xi(), " HAVING STARTED: ", time2start) 
        # 12:26:08 01/20/15 FLE Standard Time  HAVING STARTED:  12:26:08 01/20/15 FLE Standard Time
 
        
               
        return
    else:
        # -----------------------------------------------------------------------------------------
        # UNEXPECTED PARAMETER COMBINATION - ERROR
        # -----------------------------------------------------------------------------------------
        print("(STEP 7Z1/33) OF SHOOT2THIRTYTHREE4SEARCH *** ERROR IN LOGIC ***")
        print("(STEP 7Z2/33) OF SHOOT2THIRTYTHREE4SEARCH - QUEUE2THIRTYTHREE: ", queue2thirtythree)
        print("(STEP 7Z3/33) OF SHOOT2THIRTYTHREE4SEARCH - CONSUMER_CHANNEL2THIRTYTHREE: ", consumer_channel2thirtythree) 
        print("(STEP 7Z4/33) OF SHOOT2THIRTYTHREE4SEARCH - PUBLISHER_CHANNEL2THIRTYTHREE: ", publisher_channel2thirtythree)
        print("(STEP 7Z5/33) OF SHOOT2THIRTYTHREE4SEARCH - PATH2THIRTYTHREE: ", path2thirtythree)     
              
        return  
            
               
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\analyse2photo4search.txt
# \xml\ace-analyse2photo.xml
# \xml\reason-analyse2photo.xml
# \xml\sense-analyse2photo.xml
# 
#"
#>
  

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.thirtythreexi.com; www.yourthirtythreexi.com; www.yourthirtythreexi.org; www.thirtythree2xi.com/; www.thirtythree4xi.com/; www.thirtythree8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2thirtythree4search.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
